.386
.MODEL 	FLAT,STDCALL
option 	casemap:none
include	FadeTextDemo.inc

.code
Entrypoint: 
	mov hInstance,FUNC (GetModuleHandle, NULL)
	invoke InitCommonControls
	invoke ExitProcess,FUNC (DialogBoxParam,hInstance,1000,NULL,addr DlgProc,NULL)
       
DlgProc PROC hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL	idThread:DWORD
      
	mov		eax,uMsg
	.If eax==WM_INITDIALOG
		m2m hWnd,hWin
		mov PBrushD, FUNC (CreatePatternBrush,FUNC (BitmapFromResource, hInstance, 3))
		mov PBrushD2,FUNC (CreatePatternBrush,FUNC (LoadBitmap, hInstance, 2))
		invoke SendDlgItemMessage,hWin,1001,BM_SETIMAGE,IMAGE_BITMAP,FUNC (BitmapFromResource, hInstance,3)	
		invoke  CreateThread,0,2001,addr FadeFlash,hWin,0,addr idThread
		invoke  CreateThread,0,2004,addr FadeButton,hWin,0,addr idThread
		invoke  CreateThread,0,2005,addr FadeStatic,hWin,0,addr idThread
		return 0
		
	.ElseIf 	Eax == WM_CTLCOLORDLG 
		mov eax,PBrushD
		ret	
		
	.ElseIf 	Eax == WM_CTLCOLORSTATIC
		invoke GetWindowLong,lParam,GWL_ID
		.if eax > 1005 && eax < 1008
			Invoke 	SetBkMode, wParam, TRANSPARENT
			Invoke 	SetTextColor, wParam, 0FFFFh 
			mov eax,PBrushD2
			ret	
		.endif
		invoke CreateSolidBrush,00000000h ; background for ID 1002 (static)
		ret			
		
	.Elseif eax==WM_COMMAND		
		mov		edx,wParam
		movzx	eax,dx
		shr		edx,16
		.if edx==BN_CLICKED
			.if eax==1001
				invoke EndDialog,hWin,0
			.endif	
		.endif	
		
	.elseif eax==WM_CLOSE
		invoke EndDialog,hWin,0
	.Else
		return 0
	.Endif
	return 1	
DlgProc ENDP

FadeFlash PROC ; FadeText,handle,String,font,speed,mode,left,top,R,G,B (see 'Readme' for detail)
	LOCAL hand:DWORD
	
	mov hand,FUNC (GetDlgItem,hWnd,1002)				
@@:			
	fn FadeText,hand,"Fade Text",0,100,3,5,2,0,2,2 ; light blue (2,2,0)
	fn FadeText,hand,"Fade Text",0,300,3,5,2,0,0,0 ; black      (0,0,0)	
	jmp @B	
FadeFlash ENDP

FadeButton PROC
	fn FadeText,FUNC (GetDlgItem,hWnd,1001),"P U S H",0,1,1,8,5,0,1,0
	ret
FadeButton ENDP

FadeStatic PROC
	fn FadeText,FUNC (GetDlgItem,hWnd,1006),"Example",0,1,0,37,2,2,1,0
	ret
FadeStatic ENDP

end Entrypoint