.386
.MODEL 		FLAT,STDCALL
option 		casemap:none
include		FadeTextDemo.inc
include		Controls.asm ; <- I use only "StaticImage" procedure with this example. 

.code
Entrypoint:
	mov hInstance,FUNC (GetModuleHandle,0)
	invoke InitCommonControls 
	invoke ExitProcess,FUNC (DialogBoxParam,hInstance,1000,NULL,addr DlgProc,0)
       
DlgProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	
	mov		eax,uMsg 
	.If eax==WM_INITDIALOG 
		mov font1, FUNC (CreateFontA,18,0,0,0,FW_REGULAR,TRUE,0,0,0,0,0,PROOF_QUALITY,0,chr$("Times New Roman"))
		mov font2, FUNC (CreateFontA,18,0,0,0,FW_REGULAR,0,0,0,0,0,0,PROOF_QUALITY,0,chr$("Comic Sans Ms"))
		mov PBrushD, FUNC (CreatePatternBrush,FUNC (BitmapFromResource, hInstance, 2)) ; tv image 
		mov hand, FUNC (GetDlgItem,hWin,1002) ; handle black screen
		mov hAvi, FUNC (GetDlgItem,hWin,1003) ; handle anim (cool)
		mov hBmp[0], FUNC (BitmapFromResource, hInstance, 3) ; handle image 1
		mov hBmp[4], FUNC (BitmapFromResource, hInstance, 4) ; handle image 2
		mov hBmp[8], FUNC (BitmapFromResource, hInstance, 5) ; handle image 3			
		mov hStatImage[0], FUNC (StaticImage,NULL,hand,0,0,0,0,60001)  ; handle window image 1
		mov hStatImage[4], FUNC (StaticImage,NULL,hand,0,0,0,0,60001)  ; handle window image 2
		mov hStatImage[8], FUNC (StaticImage,NULL,hand,20,0,0,0,60001) ; handle window image 3
		invoke SendDlgItemMessage,hWin,1001,BM_SETIMAGE,IMAGE_BITMAP,FUNC (LoadBitmap,hInstance,6) ; 'on' button
		return 0     
        
	.Elseif eax==WM_CTLCOLORDLG 
		mov     eax,PBrushD ; place tv image
		ret
	     
	.Elseif 	Eax == WM_CTLCOLORSTATIC
		invoke CreateSolidBrush,00000000h ; put black color in tv screen (ID 1002)
		ret	
			     
	.Elseif eax==WM_COMMAND
		mov		edx,wParam
		movzx	eax,dx
		shr		edx,16
		.if edx==BN_CLICKED
			.if eax == 1001 && idThread == 0
				invoke PlaySound,8,hInstance,SND_RESOURCE or SND_ASYNC
				invoke  CreateThread,0,2000,addr FadeThread,hWin,0,addr idThread
			.endif
		.endif			     
			
	.Elseif eax==WM_CLOSE
		invoke EndDialog,hWin,0
	.Else
		return 0
	.Endif
	return 1	
DlgProc endp

FadeThread PROC ; FadeText,handle,String,font,speed,mode,left,top,R,G,B	(see 'Readme' for detail)
	fn FadeText,hand,"FadeText Static Library",font1,10,2,80,60,1,1,1
	fn FadeText,hand,"version 14.III.2005",font2,1,2,90,80,0,1,1
	fn FadeText,hand,"for fun: add image + AVI",font2,20,3,80,100,1,0,1
	mov edi,0
	
	.WHILE edi < 9 ; show images...
	invoke SendMessage,hStatImage[edi],STM_SETIMAGE,IMAGE_BITMAP,hBmp[edi]
	invoke PlaySound,9,hInstance,SND_RESOURCE or SND_ASYNC
	.if edi == 8
		fn FadeText,hand,"The End...",font1,10,2,125,210,1,1,0
	.else 
		invoke Sleep,5000
	.endif
	invoke SendMessage,hStatImage[edi],WM_CLOSE,0,0
	invoke PlaySound,9,hInstance,SND_RESOURCE or SND_ASYNC
	invoke Sleep,500
	add edi,4
	.ENDW

	invoke Sleep,500
	fn FadeText,hand,"Test AVI...",font1,1,3,120,100,1,1,1	
	invoke ShowWindow,hAvi,SW_RESTORE ; show window anim
	invoke Sleep,8000
	invoke SendMessage,hAvi,WM_CLOSE,0,0 ; or: invoke ShowWindow,hAvi,SW_HIDE
	invoke Sleep,1000
	invoke  CreateThread,0,2001,addr AddThread,hand,0,addr idThread
	mov yy,80
	mov xx,70
	mov start,0
	invoke AddThread2 ; recursive procedure for special effect
	invoke Sleep,4000
	invoke ExitProcess,0
	ret
FadeThread ENDP

AddThread PROC
	fn FadeText,hand,"fade in/out...",0,1,3,80,100,1,1,0
	fn FadeText,hand,"...example intro...",0,1,3,120,120,1,1,0
	fn FadeText,hand,"...and images...",0,1,3,50,130,1,1,0
	fn FadeText,hand,"by Faiseur",0,17,3,145,150,1,1,0
	ret
AddThread ENDP

AddThread2 PROC 
	LOCAL x:DWORD,y:DWORD,s:DWORD
	
	.if start == 10 ; max. repeat: 10x
		ret
	.endif	
	
	m2m s,start
	m2m y, yy
	m2m x, xx
	inc start
	sub yy,20
	sub xx,10
	invoke Sleep,100
	invoke  CreateThread,0,2002,addr AddThread2,hand,0,addr idThread 
	
	fn FadeText,hand,"fade in/out...",font1,7,3,x,y,1,1,0
	add y,20
	add x,40
	fn FadeText,hand,"...example intro...",font1,7,3,x,y,1,1,0
	add y,10	
	sub x,70
	fn FadeText,hand,"...and images...",font1,7,3,x,y,1,1,0
	add y,20
	add x,95
	fn FadeText,hand,"by Faiseur",font1,7,2,x,y,1,1,0
	ret
AddThread2 ENDP

end Entrypoint